/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/UnitTests/JUnit5TestClass.java to edit this template
 */
package metier;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author emile.lalorcey
 */
public class JoueurTest {
    
    public JoueurTest() {
    }
    
    @Before
    public void setUp() {
    }


    /**
     * Test of faireVarierVie method, of class Joueur.
     */
    @Test
    public void testFaireVarierVie() {
        System.out.println("--------------------------------faireVarierVie--------------------");
        Position pos = new Position();
        Joueur instance = new Joueur("Didier", 5, pos); //  complter, joueur cr avec 5 vies
        System.out.println ("\t 1er cas : moins 1 vie/5 au dpart");
        int nb = -1;
        instance.faireVarierVie(nb);
        int expResult = 4; // Rsultat attendu
        int result = instance.getNbVie(); // Rsultat rel
        assertEquals("Pb maj Vie",expResult, result );
        boolean expResultB = false;
        boolean resultB = instance.isMort();
        assertEquals("Pb maj isMort",expResultB, resultB );
        System.out.println ("\t 2nd cas : moins 6 vies/ 4");
        Joueur instan = new Joueur("Did", 4, pos);
        nb = -6;
        instan.faireVarierVie(nb);
        expResult = 0;
        result = instan.getNbVie();
        assertEquals("Pb maj Vie",expResult, result );
        expResultB = false;
        resultB = instance.isMort();
        assertEquals("Pb maj isMort",expResultB, resultB );
    }

    /**
     * Test of deplacer method, of class Joueur.
     */
    @Test
    public void testDeplacer() {
        System.out.println("--------------------deplacer----------------------");
        Joueur instance = new Joueur();
        Position pos1 = new Position(2, 2);
        instance.setPosition(pos1);
        
        System.out.println ("\t 1er cas : monter de 1");
        //Test d'un dplacement neutre vers le nord
        Position a = instance.deplacer('n', 3, 3);
        int expResult = 1;
        int result = a.getPosY();
        assertEquals("Pb dplacement",expResult, result );
        instance.setPosition(a);
        System.out.println ("\t 2er cas : hors limite vers le nord");
        a = instance.deplacer('n', 3, 3);
        instance.setPosition(a);
        a = instance.deplacer('n', 3, 3);
        expResult = 0;
        result = a.getPosY();
        assertEquals("Pb dplacement",expResult, result );
        
        System.out.println ("\t 3er cas : Est de 1");
        a = instance.deplacer('e', 3, 3);
        expResult = 2;
        result = a.getPosX();
        assertEquals("Pb dplacement",expResult, result );
        instance.setPosition(a);
        System.out.println ("\t 4er cas : hors limite vers l'Est");
        a = instance.deplacer('e', 3, 3);
        instance.setPosition(a);
        expResult = 2;
        result = a.getPosX();
        assertEquals("Pb dplacement",expResult, result );
        
        System.out.println ("\t 5er cas : Sud de 1");
        a = instance.deplacer('s', 3, 3);
        expResult = 1;
        result = a.getPosY();
        assertEquals("Pb dplacement",expResult, result );
        instance.setPosition(a);
        System.out.println ("\t 6er cas : hors limite vers le Sud");
        a = instance.deplacer('s', 3, 3);
        instance.setPosition(a);
        a = instance.deplacer('s', 3, 3);
        instance.setPosition(a);
        expResult = 2;
        result = a.getPosY();
        assertEquals("Pb dplacement",expResult, result );
        
        System.out.println ("\t 7eme cas : Ouest de 1");
        a = instance.deplacer('o', 3, 3);
        expResult = 1;
        result = a.getPosX();
        assertEquals("Pb dplacement",expResult, result );
        instance.setPosition(a);
        System.out.println ("\t 8eme cas : hors limite vers le Sud");
        a = instance.deplacer('o', 3, 3);
        instance.setPosition(a);
        a = instance.deplacer('o', 3, 3);
        instance.setPosition(a);
        expResult = 0;
        result = a.getPosX();
        assertEquals("Pb dplacement",expResult, result );
        //instance.deplacer(direction, nbCol, nbLignes);
        // TODO review the generated test code and remove the default call to fail.
    }
    
}
