/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package metier;

import java.util.Objects;
import java.util.logging.Logger;

/**
 *
 * @author emile.lalorcey
 */
public class Recif {
    private int dangerosite;
    private Position laPosition;
   
    // COnstructeur 

    public Recif() {
    }

    public Recif(int dangerosite, Position laPosition) {
        this.dangerosite = dangerosite;
        this.laPosition = laPosition;
    }
    
    // Guetteur

    public int getDangerosite() {
        return dangerosite;
    }

    public Position getLaPosition() {
        return laPosition;
    }
    
    // Setteur

    public void setDangerosite(int dangerosite) {
        this.dangerosite = dangerosite;
    }

    public void setLaPosition(Position laPosition) {
        this.laPosition = laPosition;
    }
    
    // Methodes

    @Override
    public String toString() {
        return "Recif{" + "dangerosite=" + dangerosite + ", laPosition=" + laPosition + '}';
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 19 * hash + this.dangerosite;
        hash = 19 * hash + Objects.hashCode(this.laPosition);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Recif other = (Recif) obj;
        if (this.dangerosite != other.dangerosite) {
            return false;
        }
        return Objects.equals(this.laPosition, other.laPosition);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
}
